<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" size="small" v-show="showSearch" label-width="68px">
      <el-form-item label="活动主题" prop="activityTheme">
        <el-input
          v-model="queryParams.activityTheme"
          placeholder="请输入活动主题"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="活动预期目标" prop="activityGoal" label-width="102px">
        <el-input
          v-model="queryParams.activityGoal"
          placeholder="请输入活动预期目标"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="参加人员" prop="activityAttendees">
        <el-input
          v-model="queryParams.activityAttendees"
          placeholder="请输入参加人员"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="活动日期" prop="activityDate">
        <el-date-picker clearable size="small" style="width: 200px"
          v-model="queryParams.activityDate"
          type="date"
          value-format="yyyy-MM-dd"
          placeholder="选择活动日期">
        </el-date-picker>
      </el-form-item>
      <el-form-item label="备注" prop="remarks">
        <el-input
          v-model="queryParams.remarks"
          placeholder="请输入备注"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="归属部门" prop="deptId" style="width: 268px;">
        <treeselect style="width: 200px;" v-model="queryParams.deptId" :options="deptOptions" :show-count="true" placeholder="请选择归属部门" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['branch:activity:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['branch:activity:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['branch:activity:remove']"
        >删除</el-button>
      </el-col>
      <!--<el-col :span="1.5">-->
        <!--<el-button-->
          <!--type="info"-->
          <!--plain-->
          <!--icon="el-icon-upload2"-->
          <!--size="mini"-->
          <!--@click="handleImport"-->
          <!--v-hasPermi="['branch:activity:edit']"-->
        <!--&gt;导入</el-button>-->
      <!--</el-col>-->
      <!--<el-col :span="1.5">-->
        <!--<el-button-->
          <!--type="warning"-->
          <!--plain-->
          <!--icon="el-icon-download"-->
          <!--size="mini"-->
          <!--@click="handleExport"-->
          <!--v-hasPermi="['branch:activity:export']"-->
        <!--&gt;导出</el-button>-->
      <!--</el-col>-->
	  <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="activityList" @selection-change="handleSelectionChange" :height="clientHeight" border>
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="活动主题" align="center" prop="activityTheme" width="200"/>
      <el-table-column label="活动预期目标" align="left" prop="activityGoal" width="500"/>
      <el-table-column label="参加人员" align="center" prop="activityAttendees" width="120"/>
      <el-table-column label="活动日期" align="center" prop="activityDate" width="100">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.activityDate, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="备注" align="center" prop="remarks" width="120"/>
      <el-table-column label="附件" align="center" prop="filesId" width="100" fixed="right">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-folder"
            @click="openFileDialog(scope.row)"
          >查看附件
          </el-button>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" fixed="right" width="120" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['branch:activity:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['branch:activity:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改支部特色活动对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="110px">
        <el-form-item label="活动主题" prop="activityTheme">
          <el-input v-model="form.activityTheme" placeholder="请输入活动主题" />
        </el-form-item>
        <el-form-item label="活动预期目标" prop="activityGoal">
          <el-input v-model="form.activityGoal" placeholder="请输入活动预期目标" type="textarea" rows="4"/>
        </el-form-item>
        <el-form-item label="参加人员" prop="activityAttendees">
          <el-input v-model="form.activityAttendees" placeholder="请输入参加人员" />
        </el-form-item>
        <el-form-item label="活动日期" prop="activityDate">
          <el-date-picker clearable size="small" style="width: 200px"
            v-model="form.activityDate"
            type="date"
            value-format="yyyy-MM-dd"
            placeholder="选择活动日期">
          </el-date-picker>
        </el-form-item>
        <el-form-item label="备注" prop="remarks">
          <el-input v-model="form.remarks" placeholder="请输入备注" />
        </el-form-item>
          <el-form-item label="归属部门" prop="deptId">
              <treeselect v-model="form.deptId" :options="deptOptions" :show-count="true" placeholder="请选择归属部门" />
          </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
    <!-- 附件详情对话框 -->
    <el-dialog title="附件详情" :visible.sync="file.open" width="60%" append-to-body>
      <el-row :gutter="10" class="mb8">
        <el-col :span="1.5">
          <el-upload
            ref="doc"
            :headers="doc.headers"
            :action="doc.url+'?tableName=branchActivity&tableId=' + doc.tableId"
            :disabled="doc.isUploading"
            :on-progress="handleFileDocProgress"
            :on-success="handleFileDocSuccess"
            :auto-upload="true"
            :file-list="file.fileList"
          >
            <el-button type="primary"><i class="el-icon-upload"></i> 点击上传</el-button>
          </el-upload>
        </el-col>
      </el-row>
      <el-table :data="file.dataList">
        <el-table-column label="附件名称" align="center">
          <template slot-scope="scope">
            <el-button
              size="mini"
              type="text"
              icon="el-icon-document"
              @click="handleSee(scope.row.url)">
              {{ scope.row.name }}
            </el-button>
          </template>
        </el-table-column>
        <el-table-column label="上传人" align="center" prop="creater"/>
        <el-table-column label="上传时间" align="center" prop="createdate">
          <template slot-scope="scope">
            <span>{{ parseTime(scope.row.createdate, '{y}-{m}-{d}') }}</span>
          </template>
        </el-table-column>
        <el-table-column label="操作" align="center">
          <template slot-scope="scope">
            <el-button
              size="mini"
              type="text"
              icon="el-icon-delete"
              @click="handleDeleteFile(scope.row.id)"
            >删除
            </el-button>
          </template>
        </el-table-column>
      </el-table>
    </el-dialog>
    <!-- 用户导入对话框 -->
    <el-dialog :title="upload.title" :visible.sync="upload.open" width="400px" append-to-body>
        <el-upload
                ref="upload"
                :limit="1"
                accept=".xlsx, .xls"
                :headers="upload.headers"
                :action="upload.url + '?updateSupport=' + upload.updateSupport"
                :disabled="upload.isUploading"
                :on-progress="handleFileUploadProgress"
                :on-success="handleFileSuccess"
                :auto-upload="false"
                drag
        >
            <i class="el-icon-upload"></i>
            <div class="el-upload__text">
                将文件拖到此处，或
                <em>点击上传</em>
            </div>
            <div class="el-upload__tip" slot="tip">
                <el-checkbox v-model="upload.updateSupport" />是否更新已经存在的用户数据
                <el-link type="info" style="font-size:12px" @click="importTemplate">下载模板</el-link>
            </div>
            <div class="el-upload__tip" style="color:red" slot="tip">提示：仅允许导入“xls”或“xlsx”格式文件！</div>
        </el-upload>
        <div slot="footer" class="dialog-footer">
            <el-button type="primary" @click="submitFileForm">确 定</el-button>
            <el-button @click="upload.open = false">取 消</el-button>
        </div>
    </el-dialog>
  </div>
</template>

<script>
import { listActivity, getActivity, delActivity, addActivity, updateActivity, exportActivity, importTemplate} from "@/api/branch/activity";
import { treeselect } from "@/api/system/dept";
import { getToken } from "@/utils/auth";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";
import {delFile, listFile} from "../../../../api/branch/file";

export default {
  name: "Activity",
  components: { Treeselect },
  data() {
    return {
      file: {
        id: null,
        open: false,
        fileList: [],
        dataList: [],
      },
      doc: {
        file: "",
        // 是否显示弹出层（报告附件）
        open: false,
        // 弹出层标题（报告附件）
        title: "",
        // 是否禁用上传
        isUploading: false,
        // 设置上传的请求头部
        headers: {Authorization: "Bearer " + getToken()},
        tableId: 0,
        // 上传的地址
        url: process.env.VUE_APP_BASE_API + "/branch/file/uploadFile",
      },
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: false,
      // 总条数
      total: 0,
      // 支部特色活动表格数据
      activityList: [],
      // 弹出层标题
      title: "",
      // 部门树选项
      deptOptions: [],
      clientHeight:300,
      // 是否显示弹出层
      open: false,
      // 主键id字典
      activityIdOptions: [],
      // 活动主题字典
      activityThemeOptions: [],
      // 活动预期目标字典
      activityGoalOptions: [],
      // 参加人员字典
      activityAttendeesOptions: [],
      // 活动日期字典
      activityDateOptions: [],
      // 备注字典
      remarksOptions: [],
      // 删除标志字典
      delFlagOptions: [],
      // 创建者字典
      createByOptions: [],
      // 创建时间字典
      createTimeOptions: [],
      // 更新者字典
      updateByOptions: [],
      // 更新时间字典
      updateTimeOptions: [],
      // 部门id字典
      deptIdOptions: [],
        // 用户导入参数
        upload: {
            // 是否显示弹出层（用户导入）
            open: false,
            // 弹出层标题（用户导入）
            title: "",
            // 是否禁用上传
            isUploading: false,
            // 是否更新已经存在的用户数据
            updateSupport: 0,
            // 设置上传的请求头部
            headers: { Authorization: "Bearer " + getToken() },
            // 上传的地址
            url: process.env.VUE_APP_BASE_API + "/branch/activity/importData"
        },
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 20,
        activityId: null,
        activityTheme: null,
        activityGoal: null,
        activityAttendees: null,
        activityDate: null,
        remarks: null,
        deptId: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        activityTheme: [
          { required: true, message: "活动主题不能为空", trigger: "blur" }
        ],
        activityGoal: [
          { required: true, message: "活动预期目标不能为空", trigger: "blur" }
        ],
        deptId: [
          { required: true, message: "归属部门不能为空", trigger: "blur" }
        ],
      }
    };
  },
  watch: {
        // 根据名称筛选部门树
        deptName(val) {
            this.$refs.tree.filter(val);
        }
   },
  created() {
      //设置表格高度对应屏幕高度
      this.$nextTick(() => {
          this.clientHeight = document.body.clientHeight -250
      })
    this.getList();
    this.getTreeselect();
    this.getDicts("${column.dictType}").then(response => {
      this.activityIdOptions = response.data;
    });
    this.getDicts("${column.dictType}").then(response => {
      this.activityThemeOptions = response.data;
    });
    this.getDicts("${column.dictType}").then(response => {
      this.activityGoalOptions = response.data;
    });
    this.getDicts("${column.dictType}").then(response => {
      this.activityAttendeesOptions = response.data;
    });
    this.getDicts("${column.dictType}").then(response => {
      this.activityDateOptions = response.data;
    });
    this.getDicts("${column.dictType}").then(response => {
      this.remarksOptions = response.data;
    });
    this.getDicts("${column.dictType}").then(response => {
      this.delFlagOptions = response.data;
    });
    this.getDicts("${column.dictType}").then(response => {
      this.createByOptions = response.data;
    });
    this.getDicts("${column.dictType}").then(response => {
      this.createTimeOptions = response.data;
    });
    this.getDicts("${column.dictType}").then(response => {
      this.updateByOptions = response.data;
    });
    this.getDicts("${column.dictType}").then(response => {
      this.updateTimeOptions = response.data;
    });
    this.getDicts("${column.dictType}").then(response => {
      this.deptIdOptions = response.data;
    });
  },
  methods: {
    //附件上传中处理
    handleFileDocProgress(event, file, fileList) {
      this.doc.file = file;
    },
    //附件上传成功处理
    handleFileDocSuccess(response, file, fileList) {
      console.log(response.data, '-----', this.file.id);
      this.$modal.msgSuccess("上传成功");
      this.getFileList();
    },
    handleSee(url) {
      window.open(process.env.VUE_APP_BASE_API + url);
    },
    openFileDialog(row) {
      console.log(row)
      this.file.open = true;
      this.doc.tableId = row.activityId;
      this.getFileList();
    },
    getFileList() {
      listFile({tableId: this.doc.tableId, tableName: 'branchActivity'}).then(res => {
        this.file.dataList = res.data
      })
    },
    handleDeleteFile(id) {
      this.$confirm('是否确认删除?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(function () {
        return delFile(id);
      }).then(() => {
        this.getFileList();
        this.msgSuccess("删除成功");
      })
    },
    /** 查询支部特色活动列表 */
    getList() {
      this.loading = true;
      listActivity(this.queryParams).then(response => {
        this.activityList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
     /** 查询部门下拉树结构 */
     getTreeselect() {
          treeselect().then(response => {
              this.deptOptions = response.data;
          });
     },
    // 主键id字典翻译
    activityIdFormat(row, column) {
      return this.selectDictLabel(this.activityIdOptions, row.activityId);
    },
    // 活动主题字典翻译
    activityThemeFormat(row, column) {
      return this.selectDictLabel(this.activityThemeOptions, row.activityTheme);
    },
    // 活动预期目标字典翻译
    activityGoalFormat(row, column) {
      return this.selectDictLabel(this.activityGoalOptions, row.activityGoal);
    },
    // 参加人员字典翻译
    activityAttendeesFormat(row, column) {
      return this.selectDictLabel(this.activityAttendeesOptions, row.activityAttendees);
    },
    // 活动日期字典翻译
    activityDateFormat(row, column) {
      return this.selectDictLabel(this.activityDateOptions, row.activityDate);
    },
    // 备注字典翻译
    remarksFormat(row, column) {
      return this.selectDictLabel(this.remarksOptions, row.remarks);
    },
    // 删除标志字典翻译
    delFlagFormat(row, column) {
      return this.selectDictLabel(this.delFlagOptions, row.delFlag);
    },
    // 创建者字典翻译
    createByFormat(row, column) {
      return this.selectDictLabel(this.createByOptions, row.createBy);
    },
    // 创建时间字典翻译
    createTimeFormat(row, column) {
      return this.selectDictLabel(this.createTimeOptions, row.createTime);
    },
    // 更新者字典翻译
    updateByFormat(row, column) {
      return this.selectDictLabel(this.updateByOptions, row.updateBy);
    },
    // 更新时间字典翻译
    updateTimeFormat(row, column) {
      return this.selectDictLabel(this.updateTimeOptions, row.updateTime);
    },
    // 部门id字典翻译
    deptIdFormat(row, column) {
      return this.selectDictLabel(this.deptIdOptions, row.deptId);
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        activityId: null,
        activityTheme: null,
        activityGoal: null,
        activityAttendees: null,
        activityDate: null,
        remarks: null,
        delFlag: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null,
        deptId: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.activityId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加支部特色活动";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const activityId = row.activityId || this.ids
      getActivity(activityId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改支部特色活动";
      });
    },
      /** 提交按钮 */
      submitForm() {
          this.$refs["form"].validate(valid => {
              if (valid) {
                  if (this.form.activityId != null) {
                      updateActivity(this.form).then(response => {
                          this.$modal.msgSuccess("修改成功");
                          this.open = false;
                          this.getList();
                      });
                  } else {
                      addActivity(this.form).then(response => {
                          this.$modal.msgSuccess("新增成功");
                          this.open = false;
                          this.getList();
                      });
                  }
              }
          });
      },
    /** 删除按钮操作 */
    handleDelete(row) {
      const activityIds = row.activityId || this.ids;
      this.$confirm('是否确认删除?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delActivity(activityIds);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        })
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有支部特色活动数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return exportActivity(queryParams);
        }).then(response => {
          this.download(response.msg);
        })
    },
      /** 导入按钮操作 */
      handleImport() {
          this.upload.title = "用户导入";
          this.upload.open = true;
      },
      /** 下载模板操作 */
      importTemplate() {
          importTemplate().then(response => {
              this.download(response.msg);
          });
      },
      // 文件上传中处理
      handleFileUploadProgress(event, file, fileList) {
          this.upload.isUploading = true;
      },
      // 文件上传成功处理
      handleFileSuccess(response, file, fileList) {
          this.upload.open = false;
          this.upload.isUploading = false;
          this.$refs.upload.clearFiles();
          this.$alert(response.msg, "导入结果", { dangerouslyUseHTMLString: true });
          this.getList();
      },
      // 提交上传文件
      submitFileForm() {
          this.$refs.upload.submit();
      }
  }
};
</script>

<style>
    /** 文本换行符处理 */
    .el-table .cell{
        white-space: pre-wrap;
    }
    /** textarea字体 */
    textarea {
        font-family: "Helvetica Neue",Helvetica,"PingFang SC","Hiragino Sans GB","Microsoft YaHei","微软雅黑",Arial,sans-serif;
    }
</style>
